/* $Id: Icalc.java,v 1.5 2008/12/18 14:17:53 mit Exp $ */
/* Icalc.java v4.0 */
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.text.DecimalFormat;

public class Icalc extends Applet
    implements ActionListener
{
    private TextField tfP;     // partial
    private TextField tfC;     // cent
    private TextField tfA;     // pitch
    private TextArea taA;
    private Button btT;        // calc.
    private Button btK;        // key#
    private Button btA;        // pitch a
    private Button btM, btm;   // key <<,<
    private Button btp, btP;   // key >,>>
    private Button btpM, btpP; // a -,+
    private Button btsS;       // *sv
    private Button btbM, btbP; // multiple-,+

    final int KB = 88;
    final int Oct = 12;
    final int Cent = 1200;
    final String bar = "-------------------------------\n";
    final String [] keynm = 
    {"A","B","H","C","Cis","D","Es","E","F","Fis","G","Gis"};

    int AA = 440;
    int Keyn = 49-1;
    int Pmax = 20;                   // max partial
    int MUL;                         // multiple#
    String ssp = "\t";               // tab sv
    String csp = ", ";               // , sv
    String spc = ssp;
    Font Fnt, Fnm;
    DecimalFormat df1;
 
    public void init() {
	Fnt = new Font("SansSerif", Font.PLAIN, 14);
	Fnm = new Font("MonoSpaced", Font.PLAIN, 12);
	setFont(Fnt);
	df1 = new DecimalFormat("#0.0###");
        setBackground(Color.lightGray);
	setLayout(new BorderLayout());
	int mado = 7;

	Panel p = new Panel();            // left
	p.setLayout(new GridLayout(6,1));
	add(p, "West");

	Panel q = new Panel();            // textarea
	q.setLayout(new FlowLayout());
	add(q, "Center");

	Panel r = new Panel();            // title
	r.setLayout(new GridLayout(1,1));
	add(r, "North");

	Panel s = new Panel();            // button
	s.setLayout(new GridLayout(1,6));
	add(s, "South");

	Panel t = new Panel();
	t.setLayout(new GridLayout(5,1)); // right
	add(t, "East");
	
	p.add(new Label("Cent:"));

	tfC = new TextField("0.5", mado);
	tfC.setFont(Fnm);
	tfC.addActionListener(this);
	p.add(tfC);

	p.add(new Label("Multiple:"));

	MUL = 1;
	tfP = new TextField(""+MUL, mado);
	tfP.setFont(Fnm);
	tfP.setEditable(false);
	tfP.addActionListener(this);
	p.add(tfP);

	btbM = new Button(" - ");
	p.add(btbM);
	btbM.addActionListener(this);

	btbP = new Button(" + ");
	p.add(btbP);
	btbP.addActionListener(this);

	btK = new Button("Key#");
	s.add(btK);
	btK.addActionListener(this);

	btM = new Button("<<");
	s.add(btM);
	btM.addActionListener(this);

	btm = new Button("<");
	s.add(btm);
	btm.addActionListener(this);

	btp = new Button(">");
	s.add(btp);
	btp.addActionListener(this);

	btP = new Button(">>");
	s.add(btP);
	btP.addActionListener(this);

	btA = new Button("Pitch");
	t.add(btA);
	btA.addActionListener(this);

	tfA = new TextField(mado);
	tfA.setFont(Fnm);
	tfA.setEditable(false);
	t.add(tfA);
	tfA.addActionListener(this);

	btpP = new Button(" + 1");
	t.add(btpP);
	btpP.addActionListener(this);

	btpM = new Button(" - 1");
	t.add(btpM);
	btpM.addActionListener(this);

	btsS = new Button("Tab.SV");
	t.add(btsS);
	btsS.addActionListener(this);

	taA = new TextArea("", 10, 32, TextArea.SCROLLBARS_BOTH);
	taA.setFont(Fnm);
	taA.setEditable(false);
        q.add(taA);

	btT = new Button("Inharmonicity Calculat");
	r.add(btT);
	btT.addActionListener(this);
    }

    public void start() {
	pitchd();
	set_text();
    }
  
    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == btT)        // title 	
	    calc();

	else if (e.getSource() == btM)   // <<
	    ppmm(-Oct);
	else if (e.getSource() == btm)   // <
	    ppmm(-1);
	else if (e.getSource() == btp)   // >
	    ppmm(1);
	else if (e.getSource() == btP)   // >>
	    ppmm(Oct);

 	else if (e.getSource() == btK) { // key#
	    Keyn = 49-1;
	    set_text();
	}

	else if (e.getSource() == btA) {   // pitch
	    AA = 440; 
	    pitchd();
	}

	else if (e.getSource() == btpM) {   // A-
	    AA--;
	    pitchd();
	} else if (e.getSource() == btpP) { // A+
	    AA++;
	    pitchd();
	}

	else if (e.getSource() == btsS) {   // :sv
	    if (spc.equals(csp)) {
		spc = ssp;
		btsS.setLabel("Tab.SV");
	    } else {
		spc = csp;
		btsS.setLabel(",SV");
	    }
	    calc();
	}

	else if (e.getSource() == btbP)     // p.+
	    partpm(true);
	else if (e.getSource() == btbM)     // p.-
	    partpm(false);
    }

    public void partpm(boolean sw) {
	MUL = sw ? MUL+1 : MUL-1;
	if (MUL < 1)
	    MUL = Pmax;
	else if (MUL > Pmax)
	    MUL = 1;
	tfP.setText(""+MUL);
    }

    public void pitchd() {
	tfA.setText(""+AA);
	//set_text();
    }

    public void ppmm(int num) {
	Keyn += num;
        if (Keyn < 0) 
	    Keyn += KB;
        else if (Keyn > KB-1) 
	    Keyn -= KB;
	set_text();
    }

    public void set_text() {
	taA.setText(keynm[Keyn%Oct]+"("+(Keyn+1)+"): "+
		    (float)getFreq(Keyn)+"[Hz]");
    }

    public void calc() {
	StringBuffer str = new StringBuffer(256);
	str.append("Multiple:  [cent]:   [Hz]\n");
	double cent = 0, ce;

	if (spc.equals(ssp)) 
	    str.append(bar); 

	String cen = tfC.getText();
	try {
	    cent = Double.valueOf(cen).doubleValue();
	    cent /= MUL*MUL;
	    for(int i = 1; i <= Pmax; i++) {
		ce = i*i*cent;
		str.append(i);
		str.append(spc);
		str.append(df1.format((float)ce));
		str.append(spc);
		str.append(df1.format((float)ctof(Keyn, ce, i)));
		str.append("\n");
	    }	
	    taA.setText(str.toString());
	}
	catch (NumberFormatException e) {
            taA.setText("Cent input error.");
	}
    }
    
    public double ctof(int key, double cent, int p) {
	return p*getFreq(key)*Math.pow(2, cent/Cent);
    }
    public double getFreq(int key) { // 0~87
        return AA*Math.pow(2, (key-48)/(double)Oct);
    }
}
